package com.fjhx.victoriatourist.controller.jd;

import cn.hutool.core.thread.ThreadUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpStatus;
import com.alibaba.fastjson2.JSONObject;
import com.fjhx.victoriatourist.service.jd.JdApiService;
import com.ruoyi.system.utils.ConfigUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.view.RedirectView;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Map;


/**
 * <p>
 * 京东API 前端控制器
 * </p>
 *
 * @author
 * @since 2023-11-03
 */
@Slf4j
@Controller
@RequestMapping("/open/jd")
public class JdApiController {

    @Autowired
    private JdApiService jdApiService;

    /**
     * 京东登录回调
     */
    @RequestMapping("/callback")
    public void callback(HttpServletResponse response, String code, String state) throws IOException {
        log.info("京东回调code：{},state：{}", code, state);
        if (StrUtil.isBlank(code) || StrUtil.isBlank(state)){
            response.sendError(HttpStatus.HTTP_BAD_REQUEST, "参数错误");
        }
        //获取token并且入库
        try{
            jdApiService.getAccessTokenByCode(code);
        }catch (Exception e){
            log.error("京东获取token异常", e);
            response.sendError(HttpStatus.HTTP_INTERNAL_ERROR, e.getMessage());
        }
        response.sendRedirect("http://127.0.0.1:80/callback.html");
    }


    @RequestMapping("/build2LoginUrl")
    @ResponseBody
    public String build2LoginUrl(){
        String url = jdApiService.build2LoginUrl();
//        String url = "http://127.0.0.1:80/testLogin.html?"+ IdUtil.getSnowflakeNextIdStr();

        return url;
    }



}
